local app = select(2,...);

local expansionID = 9;--69434

--Name, Description, Label, classMask, patchID, sources, requiredFact, noLongerObtainable
----classMask:    (35=Plate, 68=Mail, 3592=Leather, 400=Cloth)
local db = {

{"Sabellian's","","Sabellian Cosmetic",400,100000,{183074,{183073,183080},183075,183076,183077,183078,183079,}},
----broken valarjar cosmetics
--{"Honored Valarjar","","Honored Valarjar",400,100000,{168241,168234,168236,168238,168240,168239,168237,168242,168235,}},
--{"Honored Valarjar","","Honored Valarjar",3592,100000,{168970,168967,168975,168972,168971,168973,168968,168974,}},
--{"Honored Valarjar","","Honored Valarjar",68,100000,{168800,168803,168799,168797,168802,168801,168795,168798,168796,}},
--{"Honored Valarjar","","Honored Valarjar",35,100000,{169124,169122,169126,169121,169123,169119,169120,169125,169118,}},
--
----broken darkmoon and bloodhunter sets for any class
--{"Darkmoon Harlequin's","","Special?",0,100000,{168734,168735,168736,168738,168739,168740,168737,168294,}},
--{"Bloodhunter","","Special?",0,100000,{169006,169012,169013,169009,169008,169010,169007,169011,}},

--Missing DK Elite PvP Set
{"Crimson Gladiator's","Elite","Dragonflight Season 1",32,100000,{183542,183550,183530,183554,183546,183534,183558,183538,}},

----Plate pvp
{"Infurious","Crafted PvP","Primal Elements",35,100000,{168767,179947,}},
--Mail Pvp
{"Spirit Eagle's","Crafted PvP","Primal Elements",68,100000,{180644,180645,}},--purple
----Leather pvp
{"Elder Spirit's","Crafted PvP","Primal Elements",3592,100001,{180639,180638,}},--purple
----Cloth Pvp
{"Infurious","Crafted PvP","Primal Elements",400,100001,{180690,180679,}},
};

--Used to add alternate appearances to blizzard sets
--SetID, OriginalSourceID, AlternateApperanceID
local altAppearancesDB = {
{2621, 182594, 181650},--Druid, Vault of the Incarnates, Mythic Vest, 76112
{2645, 182774, 181635},--Shaman, Vault of the Incarnates, Mythic Vest, 76112

{2703, 180804, 180831},--Cloth Titan Keeper's Vestments, Dungeon (red)
{2701, 179945, 182935},--Cloth Titan Keeper's Vestments, WQ (blue)

{2482, 169680, 169689},--Fireplume legs
}

function AddToCollection()
  for i = 1, #db do
    if (C_TransmogCollection.GetSourceInfo(db[i][6][1])) then --checks if this is an actual set. Only needed for checking sets that are only viewable on the ptr but not yet live.
      local data = {};
      data.classMask = db[i][4];
      data.note = db[i][2];
      data.label = db[i][3];
      data.uiOrder = #db - i;
      data.name = db[i][1];
      data.patchID = db[i][5];
      data.requiredFaction = db[i][7];
      data.favorite = false;
      data.expansionID = expansionID;
      if db[i][8] == true then
        data.noLongerObtainable = true;
      end
      
      data.setID = (expansionID + 1) * app.SetsFrame.ExpandedID + db[i][6][1];
      
      data.sources = {};
      for j=1,#db[i][6] do 
        if type(db[i][6][j]) == "table" then
          if not data.altSources then data.altSources = {} end
          data.sources[db[i][6][j][1]] = false--C_TransmogCollection.GetSourceInfo(db[i][6][j][1]).isCollected;
          data.altSources[db[i][6][j][1]] = db[i][6][j][2];
          data.altSources[db[i][6][j][2]] = db[i][6][j][1];
        else
          data.sources[db[i][6][j]] = false--C_TransmogCollection.GetSourceInfo(db[i][6][j]).isCollected;
        end
      end
      
      data.description = data.note; --remove this later
      
      app.SetsFrame.AddSetToTables(data);
    end
  end
  
  for i = 1, #altAppearancesDB do
    app.SetsFrame.AddAltAppearancesToTables(altAppearancesDB[i][1],altAppearancesDB[i][2],altAppearancesDB[i][3]);
  end
end

app.ExpandedCallbacks[expansionID] = AddToCollection;
do
  for i = 1, #altAppearancesDB do
    app.ExpandedAltAppearances[altAppearancesDB[i][1]] = {altAppearancesDB[i][2],altAppearancesDB[i][3]};
  end
end

--data:
----classMask:    yes (simply use 35=Plate, 68=Mail, 3592=Leather, 400=Cloth)
----collected:    no
----description:  yes
----expansionID:  no (file dependent can hardcode)
----favorite:     no
----hidden...:    no
----label:        yes (source i.e. dungeon/leveling/islands)
----limitedTime:  no
----name:         yes
----patchID:      yes (for sorting, 80300 = patch 8.3)
----requiredFact: yes
----setID:        yes (auto gened)
----uiOrder:      yes (might just always put 0, for sorting)
----sources:      myAddition, list of items in the set